local Tasks = Tasks
local L = Tasks.L
local TasksUtils = TasksUtils
local db

Tasks:RegisterCallback("Tasks-Initialize", "TemplatesInit")

function Tasks:TemplatesInit()
  db = Tasks.db
end

Tasks.constants = {}
Tasks.constants.DAILY_RESET = 1
Tasks.constants.WEEKLY_RESET = 2
Tasks.constants.NEVER_RESET = 3

Tasks.constants.SUNDAY = 1
Tasks.constants.MONDAY = 2
Tasks.constants.TUESDAY = 3
Tasks.constants.WEDNESDAY = 4
Tasks.constants.THURSDAY = 5
Tasks.constants.FRIDAY = 6
Tasks.constants.SATURDAY = 7
Tasks.constants.CURRENT_DB_VERSION = 3

Tasks.defaults = {}

Tasks.defaults["db"] = {
  global = {
    addonEnabled = true,
    id = 0,
    editList = nil,
    displayOptions = {
      frameSettings = {
        position = {
          x = 0,
          y = 0,
        },
        anchor = "CENTER",
        hidden = false,
        locked = false,
      },
    },
    resetOptions = {
      weeklyResetDay = Tasks.constants.TUESDAY,
    },
    lists = {
      ['**'] = {
        resetFrequency = Tasks.constants.DAILY_RESET,
        taskCount = 0,
        displayOptions = {
          expanded = true,
          color = {
            r = 118,
            g = 222,
            b = 175,
          },
          taskDefaultColor = {
            r = 255,
            g = 255,
            b = 255,
          },
        },
        tasks = {
          ["**"] = {
            completedChars = {
              ["**"] = {
                completed = false,
                timestamp = nil,
              },
            },
            displayOptions = {
              color = {},
            },
          },
        },
      },
    },
    characters = {
      ["**"] = {
        disabled = false,
      },
    },
  },
}

function Tasks:NextId()
  db.global.id = db.global.id + 1
  return db.global.id - 1
end